unit uPrenos;

interface
uses Math, dialogs, classes, StdCtrls, sysutils, Forms ,varcmplx;

type
Tvyraz = array of single;

TPrenos = class(TObject)
  private
    fID: integer;
    fCit: TVyraz;
    fJmen: TVyraz;
  public
    property Citatel: TVyraz read fCit;
    property Jmenovatel: TVyraz read fJmen;
    constructor create(aID: integer; aCit, aJmen: TVyraz);
    function getlabel(radek: integer):string;
end;

TObvod = class(TObject)
  private
    fCitatel: Tvyraz;
    fJmenovatel: TVyraz;
    fImaginar: TVyraz;
    fReal: TVyraz;
    fzes: TVyraz;
    ffaze: TVyraz;
    fSeznam: TList;
  public
    property Im: TVyraz read fImaginar;
    property Re: TVyraz read fReal;
    property Zes: TVyraz read fZes;
    property Faze: TVyraz read fFaze;
    property Seznam: TList read fSeznam;
    procedure ClearAll;
    procedure Calculate(cit,jme:TVyraz);
    constructor create;
    destructor Destroy;
    function Mocnina(aCislo: single; exp: integer):single;
    procedure SetValues(a0,a1,a2,a3,a4,a5,b0,b1,b2,b3,b4,b5:single);
    procedure Statement (aList: TListBox;aPrenos: TPrenos;aGraf:string);
    function AsString (aNO: single):string;
end;

implementation

constructor TObvod.create;
begin
  fSeznam:=TList.Create;
end;

destructor TObvod.destroy;
var i: integer;
begin
   ClearAll;
   for i:= 0 to fSeznam.count-1 do TPrenos(fSeznam[i]).free;
   fseznam.Free;
end;

procedure TObvod.ClearAll;
begin
  setlength(fCitatel,0);
  setlength(fJmenovatel,0);
  setlength(freal,0);
  setlength(fImaginar,0);
  setlength(fZes,0);
  setlength(fFaze,0);
end;

procedure TObvod.SetValues(a0,a1,a2,a3,a4,a5,b0,b1,b2,b3,b4,b5:single);
var i,j,k: integer;
begin
  setlength(fCitatel,6);
  setlength(fJmenovatel,6);
  fCitatel[0]:= a0;
  fCitatel[1]:= a1;
  fCitatel[2]:= a2;
  fCitatel[3]:= a3;
  fCitatel[4]:= a4;
  fCitatel[5]:= a5;
  fJmenovatel[0]:= b0;
  fJmenovatel[1]:= b1;
  fJmenovatel[2]:= b2;
  fJmenovatel[3]:= b3;
  fJmenovatel[4]:= b4;
  fJmenovatel[5]:= b5;

  i:= 5;
  while (fcitatel[i]=0) and (fJmenovatel[i]=0)do begin
    setlength (fCitatel, i);
    setlength (fjmenovatel, i);
    i:=i-1;
    end;

  if fJmenovatel[i]=0 then
      raise exception.Create('d itatele mus bt men nebo rovan du jmenovatele'+#13#9+'d itatele je:'+#9+inttostr(length(fcitatel)-1)+#13#9+'d jmenovatele je:'+#9+inttostr(length(fjmenovatel)-1));
  while (fcitatel[i]=0) do begin
    setlength (fCitatel, i);
    i:=i-1;
  end;
  fSeznam.Add(TPrenos.Create(fSeznam.Count,fCitatel,fJmenovatel));
  Calculate(fCitatel,Fjmenovatel);
end;

function TObvod.Mocnina(aCislo: single; exp: integer):single;
var i: integer;
    pom: single;
begin
  Result:=0;
  pom:= 1;
  i:= 1;
  while i <= exp do begin
    pom := pom * aCislo;
    inc(i);
  end;
  Result := pom;
end;

procedure TObvod.Calculate(cit,jme:TVyraz);
var i,vypocet: integer;
x:single;
p: array of single;
begin
  ClearAll;
  fcitatel:=cit;
  fjmenovatel:=jme;
  vypocet:=(10*length(fCitatel))+length(fJmenovatel);
  if vypocet=11 then begin
     MessageDlg('Penos je pouze jedno slo'+#10#9+floattostr(fcitatel[0]/fjmenovatel[0]),mtInformation,[mbOk],0);
     exit;
  end;
      setlength(p,11);
      setlength(fReal,315);
      setlength(fImaginar,315);
      setlength(fZes,315);
      setlength(fFaze,315);
  try
    case vypocet of

      12:begin
      x := 0;
        for i := 0 to 314 do begin
          P[0] := (sqr((fJmenovatel[1]*cos(x)+fJmenovatel[0]))+sqr(fJmenovatel[1])*sqr(sin(x)));
          Re[i] := fCitatel[0]*(fJmenovatel[1]*cos(x)+fJmenovatel[0])/P[0];
          Im[i] := -(fCitatel[0]*fJmenovatel[1]*sin(x))/P[0];
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]<>0 then
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      22:begin
      x := 0;
        for i := 0 to 314 do begin
          P[0] := (sqr((fJmenovatel[1]*cos(x)+fJmenovatel[0]))+sqr(fJmenovatel[1])*sqr(sin(x)));
          Re[i] := (((fCitatel[1]*cos(x)+fCitatel[0])*(fJmenovatel[1]*cos(x)+fJmenovatel[0]))/P[0])+((fCitatel[1]*sqr(sin(x))*fJmenovatel[1])/P[0]);
          Im[i] := ((fCitatel[1]*sin(x)*(fJmenovatel[1]*cos(x)+fJmenovatel[0]))/P[0])-(((fCitatel[1]*cos(x)+fCitatel[0])*fJmenovatel[1]*sin(x))/P[0]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      13:begin
      x := 0;
        for i := 0 to 314 do begin
          P[0] := (fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          p[1] := (2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x));
          if ((P[0]=0) and (P[1]=0)) then continue;
          Re[i] := (fCitatel[0]*P[0])/(sqr(P[0])+ sqr(P[1]));
          Im[i] := -(fCitatel[0]*P[1])/(sqr(P[0])+ sqr(P[1]));
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      23:begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := (2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x));
          P[2] := (fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          Re[i] :=  ((fCitatel[1]*cos(x)+fCitatel[0])*P[2])/(sqr(P[2])+sqr(P[1]))+
                    ((fCitatel[1]*sin(x)*P[1])/(sqr(P[2])+sqr(P[1])));
          Im[i] :=  ((fCitatel[1]*sin(x)*P[2])/(sqr(P[2])+sqr(P[1])))-
                    ((fCitatel[1]*cos(x)+fCitatel[0])*P[1])/(sqr(P[2])+sqr(P[1]));
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

     33:begin
     x := 0;
        for i := 0 to 314 do begin
          P[1] := (2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x));
          P[2] := (sqr(cos(x))-sqr(sin(x)));
          P[3] := (fJmenovatel[2]*P[2]+fJmenovatel[1]*cos(x)+fJmenovatel[1]);
          Re[i] := (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[3])/(sqr(P[3])+sqr(P[1])))+
                   (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[1])/(sqr(P[3])+sqr(P[1])));
          Im[i] := (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[3])/(sqr(P[3])+sqr(P[1])))-
                   (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[1])/(sqr(P[3])+sqr(P[1])));
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
     end;

      14:begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := (fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3)+2*fJmenovatel[2]*cos(x)*sin(x)+
                   fJmenovatel[1]*sin(x)));
          P[2] := (fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+
                   fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          Re[i] := ((fCitatel[0]*P[2])/(sqr(P[2])+sqr(P[1])));
          Im[i] := -((fCitatel[0]*P[1])/(sqr(P[2])+sqr(P[1])));
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      24: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := (fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3)+2*fJmenovatel[2]*cos(x)*sin(x)+
                  fJmenovatel[1]*sin(x)));
          P[2] := (fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+
                  fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          Re[i] := (((fCitatel[1]*cos(x)+fCitatel[0])*P[2])/(sqr(P[2])+sqr(P[1])))+
                   ((fCitatel[1]*sin(x)*P[1])/(sqr(P[2])+sqr(P[1])));
          Im[i] := ((fCitatel[1]*sin(x)*P[2])/(sqr(P[2])+sqr(P[1])))-
                   (((fCitatel[1]*cos(x)+fCitatel[0])*P[1])/(sqr(P[2])+sqr(P[1])));
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      34: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := (fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3)+2*fJmenovatel[2]*cos(x)*sin(x)+
                   fJmenovatel[1]*sin(x)));
          P[2] := (sqr(cos(x))-sqr(sin(x)));
          P[3] := (fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+fJmenovatel[2]*P[2]+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          P[4] := (sqr(P[3])+sqr(P[1]));
          Re[i] :=  (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[3])/P[4])+
                    (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[1])/P[4]);
          Im[i] :=  (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[3])/P[4])-
                    (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[1])/P[4]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      44:begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := (3*sqr(cos(x))*sin(x)-sqr(sin(x)));
          P[2] := (fJmenovatel[3]*P[1]+2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x));
          P[3] := (sqr(cos(x))-sqr(sin(x)));
          P[4] := (Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)));
          P[5] := (fJmenovatel[3]*P[4]+fJmenovatel[2]*P[3]+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          P[6] := (sqr(P[5])+sqr(P[2]));
          Re[i] := (((fCitatel[3]*P[4]+fCitatel[2]*P[3]+fCitatel[1]*cos(x)+fCitatel[0])*P[5])/P[6])+
                   (((fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[2])/P[6]);
          Im[i] := (((fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[5])/P[6])-
                   (((fCitatel[3]*P[4]+fCitatel[2]*P[3]+fCitatel[1]*cos(x)+fCitatel[0])*P[2])/P[6]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      15: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+
                  fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-mocnina(sin(x),3))+2*fJmenovatel[2]*cos(x)*sin(x)+
                  fJmenovatel[1]*sin(x);
          P[2] := fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+
                  fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+
                  fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[3] := (sqr(P[2])+sqr(P[1]));
          Re[i] :=  (fCitatel[0]*P[2])/P[3];
          Im[i] :=  -(fCitatel[0]*P[1])/P[3];
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      25:begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+
                  fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3))+2*fJmenovatel[2]*cos(x)*sin(x)+
                  fJmenovatel[1]*sin(x);
          P[2] := fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+
                  fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+
                  fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[3] := (sqr(P[2])+sqr(P[1]));
          Re[i] := (((fCitatel[1]*cos(x)+fCitatel[0])*P[2])/P[3])+((fCitatel[1]*sin(x)*P[1])/P[3]);
          Im[i] := ((fCitatel[1]*sin(x)*P[2])/P[3])-(((fCitatel[1]*cos(x)+fCitatel[0])*P[1])/P[3]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      35: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+
                  fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3))+2*fJmenovatel[2]*cos(x)*sin(x)+
                  fJmenovatel[1]*sin(x);
          P[2] := (Mocnina(cos(x),2)-sqr(sin(x)));
          P[3] := fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+
                  fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+fJmenovatel[2]*P[2]+fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[4] := (sqr(P[3])+sqr(P[1]));
          Re[i] := (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[3])/P[4])+
                   (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[1])/P[4]);
          Im[i] := (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[3])/P[4])-
                   (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[1])/P[4]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      45: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := 3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3);
          P[2] := fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+fJmenovatel[3]*P[1]+
                  2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x);
          P[3] := (sqr(cos(x))-sqr(sin(x)));
          P[4] := Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x));
          P[5] := fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+fJmenovatel[3]*P[4]+fJmenovatel[2]*P[3]+
                  fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[6] := (sqr(P[5])+sqr(P[2]));
          Re[i] := (((fCitatel[3]*P[4]+fCitatel[2]*P[3]+fCitatel[1]*cos(x)+fCitatel[0])*P[5])/P[6])+
                   (((fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[2])/P[6]);
          Im[i] := (((fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[5])/P[6])-
                   (((fCitatel[3]*P[4]+fCitatel[2]*P[3]+fCitatel[1]*cos(x)+fCitatel[0])*P[2])/P[6]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      55: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := 3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3);
          P[2] := 4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3);
          P[3] := fJmenovatel[4]*P[2]+fJmenovatel[3]*P[1]+2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x);
          P[4] := (sqr(cos(x))-sqr(sin(x)));
          P[5] := (Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)));
          P[6] := (Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4));
          P[7] := (fJmenovatel[4]*P[6]+fJmenovatel[3]*P[5]+fJmenovatel[2]*P[4]+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          P[8] := (sqr(P[7])+sqr(P[3]));
          Re[i] := (((fCitatel[4]*P[6]+fCitatel[3]*P[5]+fCitatel[2]*P[4]+fCitatel[1]*cos(x)+fCitatel[0])*P[7])/P[8])+
                   (((fCitatel[4]*P[2]+fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[3])/P[8]);
          Im[i] := (((fCitatel[4]*P[2]+fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[7])/P[8])-
                   (((fCitatel[4]*P[6]+fCitatel[3]*P[5]+fCitatel[2]*P[4]+fCitatel[1]*cos(x)+fCitatel[0])*P[3])/P[8]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      16: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] :=  fJmenovatel[5]*(5*Mocnina(cos(x),4)*sin(x)-10*sqr(cos(x))*Mocnina(sin(x),3)+Mocnina(sin(x),5))+
                   fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+
                   fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3))+2*fJmenovatel[2]*cos(x)*sin(x)+
                   fJmenovatel[1]*sin(x);
          P[2] :=  fJmenovatel[5]*(Mocnina(cos(x),5)-10*Mocnina(cos(x),3)*sqr(sin(x))+5*cos(x)*Mocnina(sin(x),4))+
                   fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+
                   fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+ fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+
                   fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[3] :=  (sqr(P[2])+sqr(P[1]));
          Re[i] := (fCitatel[0]*P[2])/P[3];
          Im[i] :=  -(fCitatel[0]*P[1])/P[3];
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      26: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] :=  fJmenovatel[5]*(5*Mocnina(cos(x),4)*sin(x)-10*sqr(cos(x))*Mocnina(sin(x),3)+Mocnina(sin(x),5))+
                   fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+
                   fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3))+2*fJmenovatel[2]*cos(x)*sin(x)+
                   fJmenovatel[1]*sin(x);
          P[2] :=  fJmenovatel[5]*(Mocnina(cos(x),5)-10*Mocnina(cos(x),3)*sqr(sin(x))+5*cos(x)*Mocnina(sin(x),4))+
                   fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+
                   fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+ fJmenovatel[2]*(sqr(cos(x))-sqr(sin(x)))+
                   fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[3] :=  (sqr(P[2])+sqr(P[1]));
          Re[i] := (((fCitatel[1]*cos(x)+fCitatel[0])*P[2])/P[3])+
                   ((fCitatel[1]*sin(x)*P[1])/P[3]);
          Im[i] := ((fCitatel[1]*sin(x)*P[2])/P[3])-
                   (((fCitatel[1]*cos(x)+fCitatel[0])*P[1])/P[3]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      36: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] :=  fJmenovatel[5]*(5*Mocnina(cos(x),4)*sin(x)-10*sqr(cos(x))*Mocnina(sin(x),3)+Mocnina(sin(x),5))+
                   fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+
                   fJmenovatel[3]*(3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3))+2*fJmenovatel[2]*cos(x)*sin(x)+
                   fJmenovatel[1]*sin(x);
          P[2] :=  (Mocnina(cos(x),2)-sqr(sin(x)));
          P[3] :=  fJmenovatel[5]*(Mocnina(cos(x),5)-10*Mocnina(cos(x),3)*sqr(sin(x))+5*cos(x)*Mocnina(sin(x),4))+
                   fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+
                   fJmenovatel[3]*(Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)))+ fJmenovatel[2]*P[2]+fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[4] :=  (sqr(P[3])+sqr(P[1]));
          Re[i] := (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[3])/P[4])+
                   (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[1])/P[4]);
          Im[i] := (((2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[3])/P[4])-
                   (((fCitatel[2]*P[2]+fCitatel[1]*cos(x)+fCitatel[0])*P[1])/P[4]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      46: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := 3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3);
          P[2] := fJmenovatel[5]*(5*Mocnina(cos(x),4)*sin(x)-10*sqr(cos(x))*Mocnina(sin(x),3)+Mocnina(sin(x),5))+
                  fJmenovatel[4]*(4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3))+fJmenovatel[3]*P[1]+
                  2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x);
          P[3] := (Mocnina(cos(x),2)-Mocnina(sin(x),2));
          P[4] :=  Mocnina(cos(x),3)-3*cos(x)*Mocnina(sin(x),2);
          P[5] :=  fJmenovatel[5]*(Mocnina(cos(x),5)-10*Mocnina(cos(x),3)*sqr(sin(x))+5*cos(x)*Mocnina(sin(x),4))+
               fJmenovatel[4]*(Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4))+fJmenovatel[3]*P[4]+fJmenovatel[2]*P[3]+
               fJmenovatel[1]*cos(x)+fJmenovatel[0];
          P[6] :=  (sqr(P[5])+sqr(P[2]));
          Re[i] := (((fCitatel[3]*P[4]+fCitatel[2]*P[3]+fCitatel[1]*cos(x)+fCitatel[0])*P[5])/P[6])+
                   (((fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[2])/P[6]);
          Im[i] := (((fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[5])/P[6])-
                   (((fCitatel[3]*P[4]+fCitatel[2]*P[3]+fCitatel[1]*cos(x)+fCitatel[0])*P[2])/P[6]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      56: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := 3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3);
          P[2] := 4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3);
          P[3] := fJmenovatel[5]*(5*Mocnina(cos(x),4)*sin(x)-10*sqr(cos(x))*Mocnina(sin(x),3)+Mocnina(sin(x),5))+fJmenovatel[4]*P[2]+
                  fJmenovatel[3]*P[1]+2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x);
          P[4] := (sqr(cos(x))-sqr(sin(x)));
          P[5] := (Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)));
          P[6] := (Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4));
          P[7] := (fJmenovatel[5]*(Mocnina(cos(x),5)-10*Mocnina(cos(x),3)*sqr(sin(x))+5*cos(x)*Mocnina(sin(x),4))+fJmenovatel[4]*P[6])+
                  (fJmenovatel[3]*P[5]+fJmenovatel[2]*P[4]+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          P[8] := (sqr(P[7])+sqr(P[3]));
          Re[i] := (((fCitatel[4]*P[6]+fCitatel[3]*P[5]+fCitatel[2]*P[4]+fCitatel[1]*cos(x)+fCitatel[0])*P[7])/P[8])+
                   (((fCitatel[4]*P[2]+fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[3])/P[8]);
          Im[i] := (((fCitatel[4]*P[2]+fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[7])/P[8])-
                   (((fCitatel[4]*P[6]+fCitatel[3]*P[5]+fCitatel[2]*P[4]+fCitatel[1]*cos(x)+fCitatel[0])*P[3])/P[8]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;

      66: begin
      x := 0;
        for i := 0 to 314 do begin
          P[1] := 3*sqr(cos(x))*sin(x)-Mocnina(sin(x),3);
          P[2] := 4*Mocnina(cos(x),3)*sin(x)-4*cos(x)*Mocnina(sin(x),3);
          P[3] := (5*Mocnina(cos(x),4)*sin(x)-10*sqr(cos(x))*Mocnina(sin(x),3)+Mocnina(sin(x),5));
          P[4] := (fJmenovatel[5]*P[3]+fJmenovatel[4]*P[2]+fJmenovatel[3]*P[1]+2*fJmenovatel[2]*cos(x)*sin(x)+fJmenovatel[1]*sin(x));
          P[5] := (sqr(cos(x))-sqr(sin(x)));
          P[6] := (Mocnina(cos(x),3)-3*cos(x)*sqr(sin(x)));
          P[7] := (Mocnina(cos(x),4)-6*sqr(cos(x))*sqr(sin(x))+Mocnina(sin(x),4));
          P[8] := (Mocnina(cos(x),5)-10*Mocnina(cos(x),3)*sqr(sin(x))+5*cos(x)*Mocnina(sin(x),4));
          P[9] := (fJmenovatel[5]*P[8]+fJmenovatel[4]*P[7]+fJmenovatel[3]*P[6]+fJmenovatel[2]*P[5]+fJmenovatel[1]*cos(x)+fJmenovatel[0]);
          P[10] := (sqr(P[9])+sqr(P[4]));
          Re[i] := (((fCitatel[5]*P[8]+fCitatel[4]*P[7]+fCitatel[3]*P[6]+fCitatel[2]*P[5]+fCitatel[1]*cos(x)+fCitatel[0])*P[9])/P[10])+
                   (((fCitatel[5]*P[3]+fCitatel[4]*P[2]+fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[4])/P[10]);
          Im[i] := (((fCitatel[5]*P[3]+fCitatel[4]*P[2]+fCitatel[3]*P[1]+2*fCitatel[2]*cos(x)*sin(x)+fCitatel[1]*sin(x))*P[9])/P[10])-
                   (((fCitatel[5]*P[8]+fCitatel[4]*P[7]+fCitatel[3]*P[6]+fCitatel[2]*P[5]+fCitatel[1]*cos(x)+fCitatel[0])*P[4])/P[10]);
          x := x + 0.01;
             Zes[i] := abs(sqrt(sqr(Re[i])+sqr(Im[i])));
             if Re[i]=0 then continue;
             Faze[i] := radtodeg(arctan(Im[i]/Re[i]));
        end;
      end;
    end;
    except on EConvertError do begin
      Application.MessageBox('Chyba ve vpotu', 'Error');
    end;
  end;
end;

procedure TObvod.Statement(aList: TListbox;aPrenos: TPrenos;aGraf:string);
var i:integer;
begin
  aList.Clear;
    for i := 1 to 3 do
    aList.AddItem(aPrenos.getlabel(i),nil);
  aList.AddItem('',nil);
    for i := 0 to 314 do begin
          if aGraf='komplex' then
            aList.AddItem('frekvence [rad/sec] = ' + AsString(i/100) +'  Re = '+AsString(Re[i]) +'   Im = '+ AsString(Im[i]),nil)
          else
            aList.AddItem('frekvence [rad/sec] = ' + AsString(i/100) +'  Amplituda [-] = '+AsString(Zes[i]) +'   Fze [] = '+ AsString(Faze[i]),nil);
    end;
end;

function TObvod.AsString(aNO:single):string;
var s:string;
begin
   s:= floattostr(simpleroundto(aNO,-4));
   if (length(s)>2) and (length(s)<4) then s:=s+'0';
   while length(s)<>20 do s:=s+' ';
   result:= s;
end;

function TPrenos.getlabel(radek: integer):string;
var i,j: integer;
begin
  case radek of
   1: begin
     result := '           ';
     for i:=0 to length(fcit)-1 do begin
      if fcit[i]=0 then continue;
        result:= result + floattostr(simpleroundto(fcit[i],-2));
        if i<>0 then result:= result+'z'+inttostr(i);
        if i<length(fcit)-1 then result:= result + ' + ';
      end;
   end;
   2: begin
     result := 'G(z)'+ inttostr(fID) + ' = '+'----------------------------------';
   end;
   3: begin
     result := '           ';
     for j:=0 to length(fjmen)-1 do begin
        if fjmen[j]=0 then continue;
          result:= result + floattostr(simpleroundto(fjmen[j],-2));
          if j<>0 then result:= result+'z'+inttostr(j);
          if j<length(fjmen)-1 then result:= result + ' + ';
     end;
   end;
   end;

end;

constructor TPrenos.create(aID: integer; aCit, aJmen: TVyraz);
begin
  fID:= aID;
  fCit:= aCit;
  fJmen:= aJmen;
end;

end.
